//  ViewController.swift
//
//  Created by patrick piemonte on 11/26/14.
//
//  The MIT License (MIT)
//
//  Copyright (c) 2014-present patrick piemonte (http://patrickpiemonte.com/)
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software"), to deal
//  in the Software without restriction, including without limitation the rights
//  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is
//  furnished to do so, subject to the following conditions:
//
//  The above copyright notice and this permission notice shall be included in all
//  copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
//  SOFTWARE.

import UIKit
import AVFoundation
import Foundation
import AVKit

class ViewController_AVPlayer_Video: UIViewController {

    typealias CompletionHandler = (_ success:Bool) -> Void
    private var playerViewController : AVPlayerViewController = AVPlayerViewController() ;
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        
    }
  
    public func isBuild(_ url: String ,userCompletionHandler: @escaping (String?, Bool?) -> ()) {
        
        let videoURL = URL(string:  url)!
        self.playerViewController.player = AVPlayer(url: videoURL)
        self.playerViewController.player?.play()
        
        
        let mensaje:String = ""
        let isError:Bool = false
        
        let group = DispatchGroup()
        group.enter()
        
   let workItem = DispatchWorkItem {
         DispatchQueue.main.async {
            
            UIApplication.shared.keyWindow?.rootViewController?.present(self.playerViewController, animated: true, completion: nil);
         
//                    if( self.playerViewController.viewIfLoaded != nil) {
//                        // Present your ViewController only if its not present to the user currently.
//                       mensaje = url
//                        isError = false
//                        group.leave()
//                    }else{
//
//                         mensaje = "Fracaso " + UIDevice.current.systemVersion
//                         isError = true
//
//                        group.leave()
//                    }
            }
        }
        
        let queue = DispatchQueue.global()
        queue.async {
            workItem.perform()
        }
            
            // Wait for all tasks to complete, and call the completion handler
        workItem.notify(queue: DispatchQueue.main) {
            userCompletionHandler(mensaje,isError)
        }
    }
}
 
